﻿using System;
using System.Collections;
using System.IO;
using Telerik.Windows.Controls;

namespace Telerik.Windows.Examples.HeatMap
{
    public abstract class DataSourceViewModelBase : ViewModelBase
    {
        protected const string wpfPath = "/HeatMap.WPF;component/DataSources/{0}";

        protected virtual void GetData( string fileName )
        {
            Uri uri = new Uri( string.Format( DataSourceViewModelBase.wpfPath, fileName ), UriKind.RelativeOrAbsolute );
            System.Windows.Resources.StreamResourceInfo streamInfo = System.Windows.Application.GetResourceStream( uri );
            using (StreamReader fileReader = new StreamReader( streamInfo.Stream ))
            {
                GetDataCompleted( this.ParseData( fileReader ) );
            }
        }

        protected abstract void GetDataCompleted( IEnumerable data );

        protected abstract IEnumerable ParseData( TextReader dataReader );

        private void DownloadStringCompleted( object sender, System.Net.DownloadStringCompletedEventArgs e )
        {
            StringReader dataReader = new StringReader( e.Result );
            GetDataCompleted( this.ParseData( dataReader ) );
        }
    }
}