﻿using System;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GanttView;
using Telerik.Windows.Controls.Scheduling;

namespace RadGanttViewQ2
{
    public class ReadOnlyPastTasksDragDropBehavior : GanttDragDropBehavior
    {
        public override bool CanStartDrag( SchedulingDragDropState state )
        {
            var draggedRange = state.DraggedItem as IDateRange;
            return base.CanStartDrag( state ) && draggedRange != null && draggedRange.Start > DateTime.Today;
        }
        public override bool CanDrop( SchedulingDragDropState state )
        {
            return base.CanDrop( state ) && (state == null || state.TimeToDrop > DateTime.Today);
        }

    }
}
