﻿using System;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GanttView;

namespace RadGanttViewQ2
{
    public class ReadOnlyPastTasksResizeBehavior : GanttResizeBehavior
    {
        public override bool CanStartResize( Telerik.Windows.Controls.Scheduling.SchedulingResizeState state )
        {
            var resizedTask = state.ResizedItem as IDateRange;

            return base.CanStartResize( state ) && resizedTask != null && (state.IsResizeFromEnd && resizedTask.End > DateTime.Today || !state.IsResizeFromEnd && resizedTask.Start > DateTime.Today);
        }

        public override bool CanResize( Telerik.Windows.Controls.Scheduling.SchedulingResizeState state )
        {
            return base.CanResize( state ) && state != null && (!state.IsResizeFromEnd && state.DestinationSlot.Start > DateTime.Today || state.IsResizeFromEnd && state.DestinationSlot.End > DateTime.Today) && state.DestinationSlot.End >= state.DestinationSlot.Start;
        }
    }
}
